#ifndef FSLGRAPHICSEGL_WINDOW_X11_EGLNATIVEWINDOWX11_HPP
#define FSLGRAPHICSEGL_WINDOW_X11_EGLNATIVEWINDOWX11_HPP
#if ! defined(__ANDROID__) && defined(__linux__) &&  defined(EGL_USE_X11)// FIX: use another define
/****************************************************************************************************************************************************
* Copyright (c) 2014 Freescale Semiconductor, Inc.
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*    * Redistributions of source code must retain the above copyright notice,
*      this list of conditions and the following disclaimer.
*
*    * Redistributions in binary form must reproduce the above copyright notice,
*      this list of conditions and the following disclaimer in the documentation
*      and/or other materials provided with the distribution.
*
*    * Neither the name of the Freescale Semiconductor, Inc. nor the names of
*      its contributors may be used to endorse or promote products derived from
*      this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
****************************************************************************************************************************************************/

#include <FslGraphics/Window/NativeWindowSetup.hpp>
#include <FslGraphics/Window/NativeWindowSystemSetup.hpp>
#include <FslGraphicsEGL/Window/IEGLNativeWindow.hpp>
#include <FslGraphicsEGL/Window/IEGLNativeWindowSystem.hpp>
#include <FslGraphicsEGL/Window/NativeEGLSetup.hpp>
#include <EGL/egl.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

namespace Fsl
{
  class EGLNativeWindowX11;

  class EGLNativeWindowSystemX11 : public IEGLNativeWindowSystem
  {
    EGLNativeDisplayType m_hDisplay;
    std::weak_ptr<EGLNativeWindowX11> m_window;
  public:
    EGLNativeWindowSystemX11(const NativeWindowSystemSetup& setup);
    virtual ~EGLNativeWindowSystemX11();

    virtual EGLNativeDisplayType GetDisplayType() const;
    virtual std::shared_ptr<IEGLNativeWindow> CreateNativeWindow(const NativeWindowSetup& nativeWindowSetup, const NativeEGLSetup& nativeEglSetup);
    virtual bool ProcessMessages(const NativeWindowProcessMessagesArgs& args);
  };


  class EGLNativeWindowX11 : public IEGLNativeWindow
  {
    EGLNativeDisplayType m_hDisplayType;
    XVisualInfo* m_pVisual;
    Colormap m_colormap;
    EGLNativeWindowType m_hWindow;
  public:
    Atom m_wm_delete_window;

    EGLNativeWindowX11(const NativeWindowSetup& nativeWindowSetup, const NativeEGLSetup& nativeEglSetup);
    virtual ~EGLNativeWindowX11();

    virtual EGLNativeWindowType GetWindowType() const;
  };

}

#endif
#endif
